From aaebafd85fe7167cb95cd52daf6d4bc2e5c5b9e0 Mon Sep 17 00:00:00 2001
From: Katsuya Hidaka <hidakatsuya@gmail.com>
Date: Mon, 14 Apr 2025 21:37:01 +0900
Subject: Updates translations for Array#to_sentence

---
 config/locales/ar.yml    |  5 +++--
 config/locales/az.yml    |  6 +++---
 config/locales/bg.yml    |  5 +++--
 config/locales/bs.yml    |  5 +++--
 config/locales/ca.yml    |  5 +++--
 config/locales/cs.yml    |  5 +++--
 config/locales/da.yml    |  5 +++--
 config/locales/de.yml    |  5 +++--
 config/locales/el.yml    |  5 +++--
 config/locales/en-GB.yml |  5 +++--
 config/locales/en.yml    |  5 +++--
 config/locales/es-PA.yml |  4 +++-
 config/locales/es.yml    |  4 +++-
 config/locales/et.yml    |  5 +++--
 config/locales/eu.yml    |  5 +++--
 config/locales/fa.yml    |  5 +++--
 config/locales/fi.yml    |  2 --
 config/locales/fr.yml    |  2 --
 config/locales/gl.yml    |  4 +++-
 config/locales/he.yml    |  5 +++--
 config/locales/hr.yml    |  5 +++--
 config/locales/hu.yml    |  2 --
 config/locales/id.yml    |  5 +++--
 config/locales/it.yml    |  5 +++--
 config/locales/ja.yml    |  5 +++--
 config/locales/ko.yml    | 10 ++++------
 config/locales/lt.yml    |  5 +++--
 config/locales/lv.yml    |  5 +++--
 config/locales/mk.yml    |  5 +++--
 config/locales/mn.yml    |  5 +++--
 config/locales/nl.yml    |  5 +++--
 config/locales/no.yml    |  4 +++-
 config/locales/pl.yml    |  5 +++--
 config/locales/pt-BR.yml |  5 +++--
 config/locales/pt.yml    |  5 +++--
 config/locales/ro.yml    |  5 +++--
 config/locales/ru.yml    |  6 +++---
 config/locales/sk.yml    |  5 +++--
 config/locales/sl.yml    |  5 +++--
 config/locales/sq.yml    |  5 +++--
 config/locales/sr-YU.yml |  7 ++++---
 config/locales/sr.yml    |  5 +++--
 config/locales/sv.yml    |  5 +++--
 config/locales/ta-IN.yml |  5 +++--
 config/locales/th.yml    |  5 +++--
 config/locales/tr.yml    |  5 +++--
 config/locales/uk.yml    |  5 +++--
 config/locales/zh-TW.yml |  2 --
 config/locales/zh.yml    |  5 +++--
 49 files changed, 137 insertions(+), 101 deletions(-)

diff --git a/config/locales/ar.yml b/config/locales/ar.yml
index 041e3ee84..f52ec8dca 100644
--- a/config/locales/ar.yml
+++ b/config/locales/ar.yml
@@ -94,8 +94,9 @@ ar:
 # Used in array.to_sentence.
   support:
     array:
-      sentence_connector: "و"
-      skip_last_comma: false
+      last_word_connector: " و "
+      two_words_connector: " و "
+      words_connector: " ، "
 
   activerecord:
     errors:
diff --git a/config/locales/az.yml b/config/locales/az.yml
index 587cf1b67..3710566df 100644
--- a/config/locales/az.yml
+++ b/config/locales/az.yml
@@ -208,9 +208,9 @@ az:
 
   support:
     array:
-      # Rails 2.2
-      sentence_connector: "və"
-      skip_last_comma: true
+      last_word_connector: " və "
+      two_words_connector: " və "
+      words_connector: ", "
 
       # Rails 2.3
       words_connector: ", "
diff --git a/config/locales/bg.yml b/config/locales/bg.yml
index 8ed6a959e..4f5b54ae3 100644
--- a/config/locales/bg.yml
+++ b/config/locales/bg.yml
@@ -96,8 +96,9 @@ bg:
 # Used in array.to_sentence.
   support:
     array:
-      sentence_connector: "и"
-      skip_last_comma: false
+      last_word_connector: " и "
+      two_words_connector: " и "
+      words_connector: ", "
 
   activerecord:
     errors:
diff --git a/config/locales/bs.yml b/config/locales/bs.yml
index 2dc1ac654..db44cf700 100644
--- a/config/locales/bs.yml
+++ b/config/locales/bs.yml
@@ -113,8 +113,9 @@ bs:
 # Used in array.to_sentence.
   support:
     array:
-      sentence_connector: "i"
-      skip_last_comma: false
+      last_word_connector: " i "
+      two_words_connector: " i "
+      words_connector: ", "
 
   activerecord:
     errors:
diff --git a/config/locales/ca.yml b/config/locales/ca.yml
index c553be760..a52b03b1a 100644
--- a/config/locales/ca.yml
+++ b/config/locales/ca.yml
@@ -99,8 +99,9 @@ ca:
 # Used in array.to_sentence.
   support:
     array:
-      sentence_connector: "i"
-      skip_last_comma: false
+      last_word_connector: ", i "
+      two_words_connector: " i "
+      words_connector: ", "
 
   activerecord:
     errors:
diff --git a/config/locales/cs.yml b/config/locales/cs.yml
index de5add9a4..45ed70711 100644
--- a/config/locales/cs.yml
+++ b/config/locales/cs.yml
@@ -99,8 +99,9 @@ cs:
 # Used in array.to_sentence.
   support:
     array:
-      sentence_connector: "a"
-      skip_last_comma: false
+      last_word_connector: " a "
+      two_words_connector: " a "
+      words_connector: ", "
 
   activerecord:
     errors:
diff --git a/config/locales/da.yml b/config/locales/da.yml
index 0268877f8..05c9d4c3d 100644
--- a/config/locales/da.yml
+++ b/config/locales/da.yml
@@ -30,8 +30,9 @@ da:
 
   support:
     array:
-      sentence_connector: "og"
-      skip_last_comma: true
+      last_word_connector: " og "
+      two_words_connector: " og "
+      words_connector: ", "
 
   datetime:
     distance_in_words:
diff --git a/config/locales/de.yml b/config/locales/de.yml
index aeddeca71..9ad00adfa 100644
--- a/config/locales/de.yml
+++ b/config/locales/de.yml
@@ -109,8 +109,9 @@ de:
 # Used in array.to_sentence.
   support:
     array:
-      sentence_connector: "und"
-      skip_last_comma: true
+      last_word_connector: " und "
+      two_words_connector: " und "
+      words_connector: ", "
 
   activerecord:
     errors:
diff --git a/config/locales/el.yml b/config/locales/el.yml
index 3350d5879..a92609e11 100644
--- a/config/locales/el.yml
+++ b/config/locales/el.yml
@@ -96,8 +96,9 @@ el:
 # Used in array.to_sentence.
   support:
     array:
-      sentence_connector: "and"
-      skip_last_comma: false
+      last_word_connector: " και "
+      two_words_connector: " και "
+      words_connector: ", "
 
   activerecord:
     errors:
diff --git a/config/locales/en-GB.yml b/config/locales/en-GB.yml
index a2743c01e..79fd6478d 100644
--- a/config/locales/en-GB.yml
+++ b/config/locales/en-GB.yml
@@ -99,8 +99,9 @@ en-GB:
 # Used in array.to_sentence.
   support:
     array:
-      sentence_connector: "and"
-      skip_last_comma: false
+      last_word_connector: ", and "
+      two_words_connector: " and "
+      words_connector: ", "
 
   activerecord:
     errors:
diff --git a/config/locales/en.yml b/config/locales/en.yml
index 26ef5a9d6..819846e1a 100644
--- a/config/locales/en.yml
+++ b/config/locales/en.yml
@@ -95,8 +95,9 @@ en:
 # Used in array.to_sentence.
   support:
     array:
-      sentence_connector: "and"
-      skip_last_comma: false
+      last_word_connector: ", and "
+      two_words_connector: " and "
+      words_connector: ", "
 
   activerecord:
     errors:
diff --git a/config/locales/es-PA.yml b/config/locales/es-PA.yml
index 5ec513fb1..8aef90a2d 100644
--- a/config/locales/es-PA.yml
+++ b/config/locales/es-PA.yml
@@ -191,7 +191,9 @@ es-PA:
 # Used in array.to_sentence.
   support:
     array:
-      sentence_connector: "y"
+      last_word_connector: " y "
+      two_words_connector: " y "
+      words_connector: ", "
 
   actionview_instancetag_blank_option: Por favor seleccione
 
diff --git a/config/locales/es.yml b/config/locales/es.yml
index d31231d4d..fd41f275b 100644
--- a/config/locales/es.yml
+++ b/config/locales/es.yml
@@ -189,7 +189,9 @@ es:
 # Used in array.to_sentence.
   support:
     array:
-      sentence_connector: "y"
+      last_word_connector: " y "
+      two_words_connector: " y "
+      words_connector: ", "
 
   actionview_instancetag_blank_option: Por favor seleccione
 
diff --git a/config/locales/et.yml b/config/locales/et.yml
index 03dc1eabf..467fcdcb1 100644
--- a/config/locales/et.yml
+++ b/config/locales/et.yml
@@ -112,8 +112,9 @@ et:
 # Used in array.to_sentence.
   support:
     array:
-      sentence_connector: "ja"
-      skip_last_comma: false
+      last_word_connector: " ja "
+      two_words_connector: " ja "
+      words_connector: ", "
 
   activerecord:
     errors:
diff --git a/config/locales/eu.yml b/config/locales/eu.yml
index 16243bdf3..40e6ef21e 100644
--- a/config/locales/eu.yml
+++ b/config/locales/eu.yml
@@ -97,8 +97,9 @@ eu:
 # Used in array.to_sentence.
   support:
     array:
-      sentence_connector: "eta"
-      skip_last_comma: false
+      last_word_connector: " eta "
+      two_words_connector: " eta "
+      words_connector: ", "
 
   activerecord:
     errors:
diff --git a/config/locales/fa.yml b/config/locales/fa.yml
index 56e22bfaa..b124cbff9 100644
--- a/config/locales/fa.yml
+++ b/config/locales/fa.yml
@@ -98,8 +98,9 @@ fa:
   # Used in array.to_sentence.
   support:
     array:
-      sentence_connector: "و"
-      skip_last_comma: false
+      last_word_connector: " و "
+      two_words_connector: " و "
+      words_connector: "، "
 
   activerecord:
     errors:
diff --git a/config/locales/fi.yml b/config/locales/fi.yml
index 9f26ed51e..c6c90f1dc 100644
--- a/config/locales/fi.yml
+++ b/config/locales/fi.yml
@@ -33,8 +33,6 @@ fi:
       two_words_connector: " ja "
       last_word_connector: " ja "
 
-
-
   number:
     format:
       separator: ","
diff --git a/config/locales/fr.yml b/config/locales/fr.yml
index 04fd4f8a9..7a072e32f 100644
--- a/config/locales/fr.yml
+++ b/config/locales/fr.yml
@@ -111,8 +111,6 @@ fr:
 
   support:
     array:
-      sentence_connector: 'et'
-      skip_last_comma: true
       word_connector: ", "
       two_words_connector: " et "
       last_word_connector: " et "
diff --git a/config/locales/gl.yml b/config/locales/gl.yml
index 9ec81288e..51e5ed99e 100644
--- a/config/locales/gl.yml
+++ b/config/locales/gl.yml
@@ -123,7 +123,9 @@ gl:
 
   support:
     array:
-      sentence_connector: e
+      last_word_connector: " e "
+      two_words_connector: " e "
+      words_connector: ", "
 
   activerecord:
     models:
diff --git a/config/locales/he.yml b/config/locales/he.yml
index 75d71f9e1..26c37fff6 100644
--- a/config/locales/he.yml
+++ b/config/locales/he.yml
@@ -101,8 +101,9 @@ he:
 
   support:
     array:
-      sentence_connector: "וגם"
-      skip_last_comma: true
+      last_word_connector: " ו"
+      two_words_connector: " ו"
+      words_connector: ", "
 
   activerecord:
     errors:
diff --git a/config/locales/hr.yml b/config/locales/hr.yml
index 56980c4e4..83af380f0 100644
--- a/config/locales/hr.yml
+++ b/config/locales/hr.yml
@@ -90,8 +90,9 @@ hr:
 # Used in array.to_sentence.
   support:
     array:
-      sentence_connector: "i"
-      skip_last_comma: false
+      last_word_connector: " i "
+      two_words_connector: " i "
+      words_connector: ", "
 
   activerecord:
     errors:
diff --git a/config/locales/hu.yml b/config/locales/hu.yml
index 38aa68fbe..b4a864826 100644
--- a/config/locales/hu.yml
+++ b/config/locales/hu.yml
@@ -114,8 +114,6 @@
 
   support:
     array:
-#      sentence_connector: "és"
-#      skip_last_comma: true
       words_connector: ", "
       two_words_connector: " és "
       last_word_connector: " és "
diff --git a/config/locales/id.yml b/config/locales/id.yml
index 851e82d05..21291a994 100644
--- a/config/locales/id.yml
+++ b/config/locales/id.yml
@@ -95,8 +95,9 @@ id:
 
   support:
     array:
-      sentence_connector: "dan"
-      skip_last_comma: false
+      last_word_connector: ", dan "
+      two_words_connector: " dan "
+      words_connector: ", "
 
   activerecord:
     errors:
diff --git a/config/locales/it.yml b/config/locales/it.yml
index 0f1845bf2..66d084cdc 100644
--- a/config/locales/it.yml
+++ b/config/locales/it.yml
@@ -107,8 +107,9 @@ it:
 # Used in array.to_sentence.
   support:
     array:
-      sentence_connector: "e"
-      skip_last_comma: false
+      last_word_connector: " e "
+      two_words_connector: " e "
+      words_connector: ", "
 
   activerecord:
     errors:
diff --git a/config/locales/ja.yml b/config/locales/ja.yml
index 1ce8773de..59b3ce341 100644
--- a/config/locales/ja.yml
+++ b/config/locales/ja.yml
@@ -114,8 +114,9 @@ ja:
 # Used in array.to_sentence.
   support:
     array:
-      sentence_connector: "及び"
-      skip_last_comma: true
+      last_word_connector: "、"
+      two_words_connector: "、"
+      words_connector: "、"
 
   activerecord:
     errors:
diff --git a/config/locales/ko.yml b/config/locales/ko.yml
index c2ab5d09b..f2c7fa7d7 100644
--- a/config/locales/ko.yml
+++ b/config/locales/ko.yml
@@ -140,8 +140,6 @@ ko:
       words_connector: ", "
       two_words_connector: "과 "
       last_word_connector: ", "
-      sentence_connector: "그리고"
-      skip_last_comma: false
 
   activerecord:
     errors:
@@ -487,7 +485,7 @@ ko:
   label_logout: 로그아웃
   label_help: 도움말
   label_reported_issues: 보고한 일감
-  label_assigned_to_me_issues: 내가 맡은 일감 
+  label_assigned_to_me_issues: 내가 맡은 일감
   label_registered_on: 등록시각
   label_activity: 작업내역
   label_user_activity: "%{value}의 작업내역"
@@ -648,7 +646,7 @@ ko:
   label_options: 옵션
   label_copy_workflow_from: 업무흐름 복사하기
   label_permissions_report: 권한 보고서
-  label_watched_issues: 지켜보고 있는 일감 
+  label_watched_issues: 지켜보고 있는 일감
   label_related_issues: 연결된 일감
   label_applied_status: 적용된 상태
   label_loading: 읽는 중...
@@ -847,7 +845,7 @@ ko:
   enumeration_doc_categories: 문서 범주
   enumeration_activities: 작업분류(시간추적)
 
-  field_issue_to: 관련 일감 
+  field_issue_to: 관련 일감
   label_view_all_revisions: 모든 개정판 표시
   label_tag: 태그(Tag)
   label_branch: 브랜치(Branch)
@@ -1021,7 +1019,7 @@ ko:
   notice_failed_to_save_time_entries: "%{total} 개의 시간입력중 다음 %{count} 개의 저장에 실패했습니다:: %{ids}."
   label_x_issues:
     zero:  0 일감
-    one:   1 일감 
+    one:   1 일감
     other: "%{count} 일감"
   label_repository_new: 저장소 추가
   field_repository_is_default: 주 저장소
diff --git a/config/locales/lt.yml b/config/locales/lt.yml
index f26a4978c..30998b050 100644
--- a/config/locales/lt.yml
+++ b/config/locales/lt.yml
@@ -103,8 +103,9 @@ lt:
 # Used in array.to_sentence.
   support:
     array:
-      sentence_connector: "ir"
-      skip_last_comma: false
+      last_word_connector: " ir "
+      two_words_connector: " ir "
+      words_connector: ", "
 
   activerecord:
     errors:
diff --git a/config/locales/lv.yml b/config/locales/lv.yml
index b7241c902..1d43e621d 100644
--- a/config/locales/lv.yml
+++ b/config/locales/lv.yml
@@ -89,8 +89,9 @@ lv:
 
   support:
     array:
-      sentence_connector: "un"
-      skip_last_comma: false
+      last_word_connector: " un "
+      two_words_connector: " un "
+      words_connector: ", "
 
   activerecord:
     errors:
diff --git a/config/locales/mk.yml b/config/locales/mk.yml
index 83f2c86cc..ee950d96e 100644
--- a/config/locales/mk.yml
+++ b/config/locales/mk.yml
@@ -96,8 +96,9 @@ mk:
 # Used in array.to_sentence.
   support:
     array:
-      sentence_connector: "и"
-      skip_last_comma: false
+      last_word_connector: ", и "
+      two_words_connector: " и "
+      words_connector: ", "
 
   activerecord:
     errors:
diff --git a/config/locales/mn.yml b/config/locales/mn.yml
index a4161b133..af4c0a5ec 100644
--- a/config/locales/mn.yml
+++ b/config/locales/mn.yml
@@ -95,8 +95,9 @@ mn:
 # Used in array.to_sentence.
   support:
     array:
-      sentence_connector: "бас"
-      skip_last_comma: false
+      last_word_connector: " болон "
+      two_words_connector: " болон "
+      words_connector: ", "
 
   activerecord:
     errors:
diff --git a/config/locales/nl.yml b/config/locales/nl.yml
index e613c056f..18644e021 100644
--- a/config/locales/nl.yml
+++ b/config/locales/nl.yml
@@ -93,8 +93,9 @@ nl:
 # Used in array.to_sentence.
   support:
     array:
-      sentence_connector: "en"
-      skip_last_comma: false
+      last_word_connector: " en "
+      two_words_connector: " en "
+      words_connector: ", "
 
   activerecord:
     errors:
diff --git a/config/locales/no.yml b/config/locales/no.yml
index 58e4699c9..a0a08e825 100644
--- a/config/locales/no.yml
+++ b/config/locales/no.yml
@@ -2,7 +2,9 @@
 "no":
   support:
     array:
-      sentence_connector: "og"
+      last_word_connector: " og "
+      two_words_connector: " og "
+      words_connector: ", "
   direction: ltr
   date:
     formats:
diff --git a/config/locales/pl.yml b/config/locales/pl.yml
index 1ccba2ffd..4c43abc0b 100644
--- a/config/locales/pl.yml
+++ b/config/locales/pl.yml
@@ -107,8 +107,9 @@ pl:
 # Used in array.to_sentence.
   support:
     array:
-      sentence_connector: "i"
-      skip_last_comma: true
+      last_word_connector: " oraz "
+      two_words_connector: " i "
+      words_connector: ", "
 
   activerecord:
     errors:
diff --git a/config/locales/pt-BR.yml b/config/locales/pt-BR.yml
index 8d14184c1..1402dcfa1 100644
--- a/config/locales/pt-BR.yml
+++ b/config/locales/pt-BR.yml
@@ -114,8 +114,9 @@ pt-BR:
           tb: "TB"
   support:
     array:
-      sentence_connector: "e"
-      skip_last_comma: true
+      last_word_connector: " e "
+      two_words_connector: " e "
+      words_connector: ", "
 
   # Active Record
   activerecord:
diff --git a/config/locales/pt.yml b/config/locales/pt.yml
index 527f284cf..e92bb4bd3 100644
--- a/config/locales/pt.yml
+++ b/config/locales/pt.yml
@@ -6,8 +6,9 @@
 pt:
   support:
     array:
-      sentence_connector: "e"
-      skip_last_comma: true
+      last_word_connector: " e "
+      two_words_connector: " e "
+      words_connector: ", "
 
   direction: ltr
   date:
diff --git a/config/locales/ro.yml b/config/locales/ro.yml
index 06a050333..38f23ce63 100644
--- a/config/locales/ro.yml
+++ b/config/locales/ro.yml
@@ -90,8 +90,9 @@ ro:
 # Used in array.to_sentence.
   support:
     array:
-      sentence_connector: "și"
-      skip_last_comma: true
+      last_word_connector: " și "
+      two_words_connector: " și "
+      words_connector: ", "
 
   activerecord:
     errors:
diff --git a/config/locales/ru.yml b/config/locales/ru.yml
index 88cfbb487..540d961c4 100644
--- a/config/locales/ru.yml
+++ b/config/locales/ru.yml
@@ -218,9 +218,9 @@ ru:
 
   support:
     array:
-      # Rails 2.2
-      sentence_connector: "и"
-      skip_last_comma: true
+      last_word_connector: " и "
+      two_words_connector: " и "
+      words_connector: ", "
 
       # Rails 2.3
       words_connector: ", "
diff --git a/config/locales/sk.yml b/config/locales/sk.yml
index af36fceaf..2a35d0537 100644
--- a/config/locales/sk.yml
+++ b/config/locales/sk.yml
@@ -94,8 +94,9 @@ sk:
 # Used in array.to_sentence.
   support:
     array:
-      sentence_connector: "a"
-      skip_last_comma: false
+      last_word_connector: " a "
+      two_words_connector: " a "
+      words_connector: ", "
 
   activerecord:
     errors:
diff --git a/config/locales/sl.yml b/config/locales/sl.yml
index fc574a537..9c51b232c 100644
--- a/config/locales/sl.yml
+++ b/config/locales/sl.yml
@@ -94,8 +94,9 @@ sl:
 # Used in array.to_sentence.
   support:
     array:
-      sentence_connector: "in"
-      skip_last_comma: false
+      last_word_connector: " in "
+      two_words_connector: " in "
+      words_connector: ", "
 
   activerecord:
     errors:
diff --git a/config/locales/sq.yml b/config/locales/sq.yml
index a9f8b9606..f7b3e4fbd 100644
--- a/config/locales/sq.yml
+++ b/config/locales/sq.yml
@@ -95,8 +95,9 @@ sq:
 # Used in array.to_sentence.
   support:
     array:
-      sentence_connector: "dhe"
-      skip_last_comma: false
+      last_word_connector: ", dhe "
+      two_words_connector: " dhe "
+      words_connector: ", "
 
   activerecord:
     errors:
diff --git a/config/locales/sr-YU.yml b/config/locales/sr-YU.yml
index 713522f4c..5d83fa6e2 100644
--- a/config/locales/sr-YU.yml
+++ b/config/locales/sr-YU.yml
@@ -98,8 +98,9 @@ sr-YU:
 # Used in array.to_sentence.
   support:
     array:
-      sentence_connector: "i"
-      skip_last_comma: false
+      last_word_connector: ", i "
+      two_words_connector: " i "
+      words_connector: ", "
 
   activerecord:
     errors:
@@ -296,7 +297,7 @@ sr-YU:
   field_delay: Kašnjenje
   field_assignable: Problem može biti dodeljen ovoj ulozi
   field_redirect_existing_links: Preusmeri postojeće veze
-  field_estimated_hours: Procenjeno vreme 
+  field_estimated_hours: Procenjeno vreme
   field_column_names: Kolone
   field_time_zone: Vremenska zona
   field_searchable: Može da se pretražuje
diff --git a/config/locales/sr.yml b/config/locales/sr.yml
index 72a80820d..baeb0ad21 100644
--- a/config/locales/sr.yml
+++ b/config/locales/sr.yml
@@ -96,8 +96,9 @@ sr:
 # Used in array.to_sentence.
   support:
     array:
-      sentence_connector: "и"
-      skip_last_comma: false
+      last_word_connector: ", и "
+      two_words_connector: " и "
+      words_connector: ", "
 
   activerecord:
     errors:
diff --git a/config/locales/sv.yml b/config/locales/sv.yml
index 7acc6bd13..607c43427 100644
--- a/config/locales/sv.yml
+++ b/config/locales/sv.yml
@@ -178,8 +178,9 @@ sv:
 # Used in array.to_sentence.
   support:
     array:
-      sentence_connector: "och"
-      skip_last_comma: true
+      last_word_connector: " och "
+      two_words_connector: " och "
+      words_connector: ", "
 
   actionview_instancetag_blank_option: Var god välj
 
diff --git a/config/locales/ta-IN.yml b/config/locales/ta-IN.yml
index a22e2cdf9..6521837ec 100644
--- a/config/locales/ta-IN.yml
+++ b/config/locales/ta-IN.yml
@@ -99,8 +99,9 @@ ta-IN:
 # Used in array.to_sentence.
   support:
     array:
-      sentence_connector: "மற்றும்"
-      skip_last_comma: false
+      last_word_connector: ", மற்றும் "
+      two_words_connector: " மற்றும் "
+      words_connector: ", "
 
   activerecord:
     errors:
diff --git a/config/locales/th.yml b/config/locales/th.yml
index ceb9030ae..b84a5d43a 100644
--- a/config/locales/th.yml
+++ b/config/locales/th.yml
@@ -93,8 +93,9 @@ th:
 # Used in array.to_sentence.
   support:
     array:
-      sentence_connector: "and"
-      skip_last_comma: false
+      last_word_connector: ", และ "
+      two_words_connector: " และ "
+      words_connector: ", "
 
   activerecord:
     errors:
diff --git a/config/locales/tr.yml b/config/locales/tr.yml
index 75280bcc6..f1c8a8c0d 100644
--- a/config/locales/tr.yml
+++ b/config/locales/tr.yml
@@ -108,8 +108,9 @@ tr:
 
   support:
     array:
-      sentence_connector: "ve"
-      skip_last_comma: true
+      last_word_connector: " ve "
+      two_words_connector: " ve "
+      words_connector: ", "
 
   activerecord:
     errors:
diff --git a/config/locales/uk.yml b/config/locales/uk.yml
index 573d66963..83868a72a 100644
--- a/config/locales/uk.yml
+++ b/config/locales/uk.yml
@@ -109,8 +109,9 @@ uk:
 # Used in array.to_sentence.
   support:
     array:
-      sentence_connector: "і"
-      skip_last_comma: false
+      last_word_connector: " та "
+      two_words_connector: " і "
+      words_connector: ", "
 
   activerecord:
     errors:
diff --git a/config/locales/zh-TW.yml b/config/locales/zh-TW.yml
index 2f9813a73..261970d0c 100644
--- a/config/locales/zh-TW.yml
+++ b/config/locales/zh-TW.yml
@@ -42,8 +42,6 @@
       words_connector: ", "
       two_words_connector: " 和 "
       last_word_connector: ", 和 "
-      sentence_connector: "且"
-      skip_last_comma: false
 
   number:
     # 使用於 number_with_delimiter()
diff --git a/config/locales/zh.yml b/config/locales/zh.yml
index 01545bf20..11a5dcdb9 100644
--- a/config/locales/zh.yml
+++ b/config/locales/zh.yml
@@ -99,8 +99,9 @@ zh:
 # Used in array.to_sentence.
   support:
     array:
-      sentence_connector: "和"
-      skip_last_comma: false
+      words_connector: ", "
+      two_words_connector: " 和 "
+      last_word_connector: ", 和 "
 
   activerecord:
     errors:
-- 
2.45.2